IcedTea-Web NetX

## net.sourceforge.jnlp.util
Class JarFile

    java.lang.Object
      java.util.zip.ZipFile
          java.util.jar.JarFile
              net.sourceforge.jnlp.util.JarFile

All Implemented Interfaces:
  java.io.Closeable

    public class JarFile

extends java.util.jar.JarFile
implements java.io.Closeable

Field Summary
`static int` `CENATT`
`static int` `CENATX`
`static int` `CENCOM`
`static int` `CENCRC`
`static int` `CENDSK`
`static int` `CENEXT`
`static int` `CENFLG`
`static int` `CENHDR`
`static int` `CENHOW`
`static int` `CENLEN`
`static int` `CENNAM`
`static int` `CENOFF`
`static long` `CENSIG`
`static int` `CENSIZ`
`static int` `CENTIM`
`static int` `CENVEM`
`static int` `CENVER`
`static int` `ENDCOM`
`static int` `ENDHDR`
`static int` `ENDOFF`
`static long` `ENDSIG`
`static int` `ENDSIZ`
`static int` `ENDSUB`
`static int` `ENDTOT`
`static int` `EXTCRC`
`static int` `EXTHDR`
`static int` `EXTLEN`
`static long` `EXTSIG`
`static int` `EXTSIZ`
`static int` `LOCCRC`
`static int` `LOCEXT`
`static int` `LOCFLG`
`static int` `LOCHDR`
`static int` `LOCHOW`
`static int` `LOCLEN`
`static int` `LOCNAM`
`static long` `LOCSIG`
`static int` `LOCSIZ`
`static int` `LOCTIM`
`static int` `LOCVER`

Fields inherited from class java.util.jar.JarFile
`MANIFEST_NAME`

Fields inherited from class java.util.zip.ZipFile
`OPEN_DELETE, OPEN_READ`

Constructor Summary
`JarFile(java.io.File file)`
`JarFile(java.io.File file, boolean verify)`
`JarFile(java.io.File file, boolean verify, int mode)`
`JarFile(java.lang.String name)`
`JarFile(java.lang.String name, boolean verify)`

Method Summary
`static void` `verifyZipHeader(java.io.File file)` This method is checking first four bytes of jar-file against ZIP_LOCAL_FILE_HEADER_SIGNATURE Although zip specification allows to skip all corrupted entries, it is not safe for jars.

Methods inherited from class java.util.jar.JarFile
`entries, getEntry, getInputStream, getJarEntry, getManifest`

Methods inherited from class java.util.zip.ZipFile
`close, finalize, getName, size`

Methods inherited from class java.lang.Object
`clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface java.io.Closeable
`close`

Field Detail

### LOCSIG

    public static final long LOCSIG

See Also:
  Constant Field Values

### EXTSIG

    public static final long EXTSIG

See Also:
  Constant Field Values

### CENSIG

    public static final long CENSIG

See Also:
  Constant Field Values

### ENDSIG

    public static final long ENDSIG

See Also:
  Constant Field Values

### LOCHDR

    public static final int LOCHDR

See Also:
  Constant Field Values

### EXTHDR

    public static final int EXTHDR

See Also:
  Constant Field Values

### CENHDR

    public static final int CENHDR

See Also:
  Constant Field Values

### ENDHDR

    public static final int ENDHDR

See Also:
  Constant Field Values

### LOCVER

    public static final int LOCVER

See Also:
  Constant Field Values

### LOCFLG

    public static final int LOCFLG

See Also:
  Constant Field Values

### LOCHOW

    public static final int LOCHOW

See Also:
  Constant Field Values

### LOCTIM

    public static final int LOCTIM

See Also:
  Constant Field Values

### LOCCRC

    public static final int LOCCRC

See Also:
  Constant Field Values

### LOCSIZ

    public static final int LOCSIZ

See Also:
  Constant Field Values

### LOCLEN

    public static final int LOCLEN

See Also:
  Constant Field Values

### LOCNAM

    public static final int LOCNAM

See Also:
  Constant Field Values

### LOCEXT

    public static final int LOCEXT

See Also:
  Constant Field Values

### EXTCRC

    public static final int EXTCRC

See Also:
  Constant Field Values

### EXTSIZ

    public static final int EXTSIZ

See Also:
  Constant Field Values

### EXTLEN

    public static final int EXTLEN

See Also:
  Constant Field Values

### CENVEM

    public static final int CENVEM

See Also:
  Constant Field Values

### CENVER

    public static final int CENVER

See Also:
  Constant Field Values

### CENFLG

    public static final int CENFLG

See Also:
  Constant Field Values

### CENHOW

    public static final int CENHOW

See Also:
  Constant Field Values

### CENTIM

    public static final int CENTIM

See Also:
  Constant Field Values

### CENCRC

    public static final int CENCRC

See Also:
  Constant Field Values

### CENSIZ

    public static final int CENSIZ

See Also:
  Constant Field Values

### CENLEN

    public static final int CENLEN

See Also:
  Constant Field Values

### CENNAM

    public static final int CENNAM

See Also:
  Constant Field Values

### CENEXT

    public static final int CENEXT

See Also:
  Constant Field Values

### CENCOM

    public static final int CENCOM

See Also:
  Constant Field Values

### CENDSK

    public static final int CENDSK

See Also:
  Constant Field Values

### CENATT

    public static final int CENATT

See Also:
  Constant Field Values

### CENATX

    public static final int CENATX

See Also:
  Constant Field Values

### CENOFF

    public static final int CENOFF

See Also:
  Constant Field Values

### ENDSUB

    public static final int ENDSUB

See Also:
  Constant Field Values

### ENDTOT

    public static final int ENDTOT

See Also:
  Constant Field Values

### ENDSIZ

    public static final int ENDSIZ

See Also:
  Constant Field Values

### ENDOFF

    public static final int ENDOFF

See Also:
  Constant Field Values

### ENDCOM

    public static final int ENDCOM

See Also:
  Constant Field Values

Constructor Detail

### JarFile

    public JarFile(java.lang.String name)
            throws java.io.IOException

Throws:
  `java.io.IOException`

### JarFile

    public JarFile(java.lang.String name,
                   boolean verify)
            throws java.io.IOException

Throws:
  `java.io.IOException`

### JarFile

    public JarFile(java.io.File file)
            throws java.io.IOException

Throws:
  `java.io.IOException`

### JarFile

    public JarFile(java.io.File file,
                   boolean verify)
            throws java.io.IOException

Throws:
  `java.io.IOException`

### JarFile

    public JarFile(java.io.File file,
                   boolean verify,
                   int mode)
            throws java.io.IOException

Throws:
  `java.io.IOException`

Method Detail

### verifyZipHeader

    public static void verifyZipHeader(java.io.File file)
                                throws java.io.IOException

  This method is checking first four bytes of jar-file against ZIP_LOCAL_FILE_HEADER_SIGNATURE Although zip specification allows to skip all corrupted entries, it is not safe for jars. If first four bytes of file are not zip ZIP_LOCAL_FILE_HEADER_SIGNATURE then exception is thrown As noted, ZIP_LOCAL_FILE_HEADER_SIGNATURE is not ile-header, but is item-header. Possible attack is using the fact that entries without header are considered corrupted and so can be ignoered. However, for other they can have some meaning. So for our purposes we must insists on first record to be valid.

  Parameters:
    `file` -
  Throws:
    `IOException,` - InvalidJarHeaderException
    `java.io.IOException`

IcedTea-Web NetX

Submit a bug or feature